#include <stdio.h>
#include <math.h>

  /* Ucitava n, k i nalazi broj koji se dobiva iz n
     ciklickom rotacijom njegovih binarnih znamenki
     za k mjesta udesno (->).
     m = broj bitova za prikaz unsigned int.
     Koristi funkciju pow(2, nesto) iz <math.h>.
     Umjesto toga, potenciju 2^nesto mozemo izracunati for petljom.
  */

int main(void)
{
    unsigned int n, m, k, rez, pot, odgovor;

    printf(" Upisi nenegativne brojeve n i k: ");
    scanf("%u %u", &n, &k);
    printf("\n n = %u, k = %u\n", n, k);

    m = sizeof(unsigned int) * 8;

        /* Za svaki slucaj, za k uzmemo ostatak pri dijeljenju
           ulaznog k s m, tako da je 0 <= k < m. */
    k %= m;

        /* Potencija od 2 na kojoj ``rezemo'' binarni prikaz broja.
           Donji dio broja n je n % rez, gornji je n / rez. */
    rez = (unsigned int) pow(2, k);

        /* Treba zamijeniti gornji i donji dio u prikazu.
           U terminima brojeva, donji dio treba pomaknuti prema gore
           za m-k bitova, tj. pomnoziti s pot = 2 na (m-k). */
    pot = (unsigned int) pow(2, m-k);

        /* Zamjena zapisana aritmetickim operacijama. */
    odgovor = n / rez + (n % rez) * pot;

    printf(" Udesno pomaknuti broj je %u\n", odgovor);

    return 0;
}
