  /* Zadatak 8.5.3. (str. 93--94)

     Napisite dio programa koji ucitava prirodni broj n i ispisuje
     sve njegove razlicite proste faktore, svakog samo jednom.
     Napomena: sve radimo u tipu int (ignoriramo brojeve <= 0).
  */

  /* Prva varijanta algoritma --- po definiciji:
       - test svih mogucih faktora izmedju 2 i n,
         provjeri je li faktor broja i prost.
  */

#include <stdio.h>
#include <math.h>

int prost_3(int n)
{
        /* Prvo testira parnost (djelitelj 2), a onda testira sve
           neparne djelitelje od 2 do max_d = (int) sqrt(n). */

    int d;        /* Potencijalni djelitelj. */
    int max_d;    /* Maksimalni potencijalni djelitelj. */

        /* Brojevi <= 1 nisu prosti (ignoriramo <= 0). */
    if (n <= 1) return 0;


        /* Testiraj parnost broja. Ako je paran, samo 2 je prost. */
    if (n % 2 == 0) return (n == 2);

        /* Najveci djelitelj kojeg treba provjeriti je
             max_d = (int) sqrt(n).
           Naime, ako n nije prost, onda ima dva netrivijalna djelitelja,
           a manji od njih je najvise jednak max_d. Ako takav djelitelj od n
           ne postoji, onda je n prost. */
        /* Napomena: Zaokruzivanje sqrt(n) na donje cijelo je korektno
           na cijelom tipu za n, tj. ne moza se dogoditi da dobijemo za
           jedan premalo. Posebno, za brojeve n koji su potpun kvadrat,
           uvijek dobijemo korektan cjelobrojni korijen. */
    max_d = (int) sqrt(n);

        /* Petlja po mogucim neparnim djeliteljima od n od 3 do max_d. */
    for (d = 3; d <= max_d; d += 2)
        if (n % d == 0) return 0;    /* Nije prost. */

    return 1;
}


int main(void)
{
    int n, d;

    printf(" Upisi broj n: ");
    scanf("%d", &n);

    printf("\n Prosti faktori od %d su:", n);

        /* Petlja po svim mogucim faktorima od n, od 2 do n. */
        /* Provjeri je li d faktor i prost.
           Koristimo skraceno racunanje logickih izraza. */
    for (d = 2; d <= n; ++d)
        if (n % d == 0 && prost_3(d))
            printf(" %d", d);

    printf("\n");

    return 0;
}
