  /* Zadatak:
       Ispisati tablicu svih prostih faktora (svakog samo jednom)
       za sve prirodne brojeve od 2 do 10000.
  */

  /* Koristimo petu (najbrzu) varijantu funkcije za proste faktore:
       - nalazi redom faktore, pocev od 2, a zatim samo po neparnim,
         do najvise (int) sqrt(n),
         i dijeli ih iz n, te popravlja granicu prema trenutnom n,
       - na kraju, ako je preostali kvocijent > 1, obradi i njega
         kao prosti faktor.

     Napomena: sve radimo u tipu int (ignoriramo brojeve <= 0).
  */

#include <stdio.h>
#include <math.h>

void ispis_prost_fakt_5(int n)
{
        /* Testira redom faktore od n, pocev od 2, a onda po neparnim do
           max_d = (int) sqrt(n), i dijeli ih iz n, uz popravak max_d. */

    int d, max_d;

        /* Brojevi <= 1 nemaju proste faktore (ignoriramo <= 0). */
    if (n <= 1) return;

        /* Gornja granica za faktor je max_d = (int) sqrt(n). */

    max_d = (int) sqrt(n);

        /* Prvo testiramo faktor 2, podijelimo ga iz broja
           i popravimo granicu. */

    if (2 <= max_d && n % 2 == 0) {
        printf(" %d", 2);

            /* Dijeli n s 2, sve dok je djeljiv. */
        do
            n /= 2;
        while (n % 2 == 0);

            /* Popravi max_d prema trenutnom n. */
        max_d = (int) sqrt(n);
        }

        /* Petlja po svim mogucim neparnim faktorima od n, pocev od 3,
           do najvise max_d = (int) sqrt(n).
           Ako je d faktor, podijeli n s tim faktorom dok ide.
           Takav faktor je sigurno prost, */

    for (d = 3; d <= max_d; d += 2)
        if (n % d == 0) {
            printf(" %d", d);

                /* Dijeli n s d, sve dok je djeljiv. */
            do
                n /= d;
            while (n % d == 0);

                /* Popravi max_d prema trenutnom n. */
            max_d = (int) sqrt(n);
        }

        /* Ako je preostali kvocijent u n > 1, i to je prosti faktor. */
    if (n > 1)
        printf(" %d", n);

    return;
}


    /* Tablica prostih faktora brojeva od 2 do 10000.
       Svaki prosti broj pise u novom redu. */

int main(void)
{
    int n, max_n = 10000;

    printf(" Tablica prostih faktora brojeva do %d\n\n", max_n);

    for (n = 2; n <= max_n; ++n) {
        printf(" Prosti faktori od %5d su:", n);
        ispis_prost_fakt_5(n);
        printf("\n");
    }

    return 0;
}
