  /* Vjezbe: Zadatak 10.1.10. (str. 114), modificiran

     Napisite funkciju koja dobiva prirodni broj n i vraca
     broj razlicitih prostih faktora tog broja, s tim da svaki faktor
     broji samo jednom.
     Napomena: sve radimo u tipu int (ignoriramo brojeve <= 0).
  */

  /* Cetvrta varijanta funkcije --- dijeljenje broja uz dinamicku granicu:
       - nalazi redom faktore, pocev od 2, do najvise (int) sqrt(n),
         i dijeli ih iz n, te popravlja granicu prema trenutnom n,
       - na kraju, ako je preostali kvocijent > 1, obradi i njega
         kao prosti faktor.

     Glavni program testira funkciju - tako da za zadani broj max_n,
     ispisuje zbroj vrijednosti funkcije za brojeve od 2 do max_n.

     Dodana je stoperica (v. Prog2, zadnje predavanje) i ispis vremena.
  */

#include <stdio.h>
#include <math.h>
#include <time.h>


    /* Funkcija za procesorsko vrijeme u sekundama. */

double dsecnd (void) {
    return (double)( clock( ) ) / CLOCKS_PER_SEC;
}


    /* Funckija za broj razlicitih prostih djelitelja broja. */

int broj_prost_fakt_4(int n)
{
        /* Testira redom faktore od n, pocev od 2, do
           max_d = (int) sqrt(n), i dijeli ih iz n, uz popravak max_d. */

    int br_pfakt = 0;
    int d, max_d;

        /* Brojevi <= 1 nemaju proste faktore (ignoriramo <= 0). */
    if (n <= 1) return 0;

        /* Petlja po svim mogucim faktorima od n, pocev od 2,
           do najvise max_d = (int) sqrt(n).
           Ako je d faktor, podijeli n s tim faktorom dok ide.
           Takav faktor je sigurno prost, */

    max_d = (int) sqrt(n);

        /* Petlja po mogucim faktorima od n od 2 do max_d. */
    for (d = 2; d <= max_d; ++d)
        if (n % d == 0) {
                /* Obrada prostog faktora d, samo jednom. */
            ++br_pfakt;

                /* Dijeli n s d, sve dok je djeljiv. */
            do
                n /= d;
            while (n % d == 0);

                /* Popravi max_d prema trenutnom n. */
            max_d = (int) sqrt(n);
        }

        /* Ako je preostali kvocijent u n > 1, i to je prosti faktor. */
    if (n > 1)
            /* Obrada prostog faktora n, samo jednom. */
        ++br_pfakt;

    return br_pfakt;
}


int main(void)
{
    int max_n = 100000;     /* Maksimalni broj n u testu. */
    int n;                  /* Broj cije proste faktore trazimo. */
    int sum_pfakt;          /* Zbroj brojeva prostih faktora. */
    double t1, t2, time;    /* Vremena za stopericu. */

    printf("\n Funkcija  broj_prost_fakt_4:\n");
    printf("   Trazim zbroj brojeva svih razlicitih prostih faktora\n");
    printf("   brojeva od 2 do max_n = %d\n", max_n);
    sum_pfakt = 0;

    t1 = dsecnd( );    /* Pocetak mjerenja vremena. */
    for (n = 2; n <= max_n; ++n)
        sum_pfakt += broj_prost_fakt_4(n);
    t2 = dsecnd( );    /* Kraj mjerenja vremena. */
    time = t2 - t1;

    printf("   Trazeni zbroj brojeva = %d,   vrijeme = %9.6f s\n",
           sum_pfakt, time);

    return 0;
}
