#include <stdio.h>

  /* Ucitava prirodni broj n i nalazi odgovor na pitanje:
     je li broj n (pozitivna) potencija od 2,
     tj. je li n == 2 na k (2^k), uz k > 0.
     Realizacija FUNKCIJOM koja vraca odgovor (kao vrijednost)
     i pripadni k, kroz tzv. varijabilni argument.
       Unistava n dijeljenjem.
       Kod funkcije, to nije problem, jer je n lokalna varijabla.
  */

int odgovor(unsigned int n, unsigned int d,
            unsigned int *pk)
{
    unsigned int k;

    k = 0;
        /* Sve dok je n djeljiv s d,
           podijeli ga s d. */
    while (n % d == 0) {
        ++k;
        n /= d;
    }
    *pk = k;
        /* Mora ostati n == 1. */
    return n == 1 && k > 0;
}

int main(void)
{
    unsigned int n, d = 2, k;

    printf(" Upisi prirodni broj n: ");
    scanf("%u", &n);
    printf("\n n = %u\n", n);

    if ( odgovor(n, d, &k) )
        printf(" Odgovor je DA\n");
    else
        printf(" Odgovor je NE\n");

    printf(" Najveci eksponent od %u u n je %u\n", d, k);

    return 0;
}
