#include <stdio.h>

/****************************************************************************/

  /* Insertion sort algoritam (sortiranje umetanjem).
     Ubrzana varijanta - prvo nadji najmanjeg i dovedi ga na pocetak.
     Sortirani dio je spijeda. Sekvencijalno trazenje prema pocetku.
     Ako je novi element najveci, ima (nepotrebna) kopiranja.
  */

/****************************************************************************/

  /* Uzlazno sortiranje (sortiranim) umetanjem.
     Sortirani dio je sprijeda.
     Prvo dovodimo najmanji na pocetak.
     Ako je sljedeci element veci, ima viska kopiranja. */

void insertion_sort(int x[], int n)
{
    int i, j, temp;

        /* Prvo nadji najmanjeg i dovedi ga na pocetak. */
    i = 0;
    temp = x[0];
    for (j = 1; j < n; ++j)
        if (x[j] < temp) {
            i = j;
            temp = x[j];
        }
    if (i != 0) {
        x[i] = x[0];
        x[0] = temp;
    }

        /* Sljedeci element x[1] je veci od najmanjeg x[0],
           pa sortiranje umetanjem pocinjemo od x[2].
           Zato sto je x[0] najmanji, u unutarnjoj petlji
           vise NE treba testirati j >= 1, jer je sigurno
           x[0] <= temp. */
    for (i = 2; i < n; ++i) {
        temp = x[i];
        for (j = i; x[j - 1] > temp; --j)
            x[j] = x[j - 1];
        x[j] = temp;
    }

    return;
}

/****************************************************************************/

int main(void)
{
    int i, n;
    int x[] = {42, 12, 55, 94, 18, 44, 67};

    n = 7;
    insertion_sort(x, n);

    printf("\n Sortirano polje x:\n");
    for (i = 0; i < n; ++i) {
        printf(" x[%d] = %d\n", i, x[i]);
    }

    return 0;
}
